
# Change this to the path to your GCC cross-compiler and target platform
export TOOLCHAIN=/c/gcc
export TARGET=i586-elf

# These should not need to be changed
export CC=$TOOLCHAIN/bin/$TARGET-gcc
export LD=$TOOLCHAIN/bin/$TARGET-ld

# Compile the bootsector
echo Compiling bootsector...
$CC -o bootsect.o -c bootsect.S
$LD --oformat=binary -Ttext=0x7C00 -o bootsect bootsect.o

# Compile the kernel
echo Compiling kernel...
$CC -o startup.o -c startup.S -ffreestanding
$CC -o kernel.o -c kernel.c -ffreestanding
$LD --oformat=binary -o sampleos.img startup.o kernel.o

# Make the floppy disk image. I am using imdisk under MSYS under Windows. If you
# have a different platform, change this code accordingly
echo Making disk image...
cat bootsect /dev/zero | dd of=floppy.img bs=512 count=2880
imdisk -a -t file -m A: -f floppy.img -o fd,rem
mount /a A:
cp sampleos.img /a/sampleos.img
sleep 1
umount /a
imdisk -D -m A:
cp floppy.img _floppy.img
