/* This is a minimal kernel with minimal graphics abilities.
 * Do whatever you want with that code snippet.
 */

/* The maximal resolution we have is 320x200, 256 colors.
 * Here are the most frequently used colors
 */
#define BLACK			0x00
#define BLUE			0x01
#define GREEN			0x02
#define CYAN			0x03
#define RED				0x04
#define MAGENTA			0x05
#define BROWN			0x06
#define LIGHT_GRAY		0x07
#define DARK_GRAY		0x08
#define LIGHT_BLUE		0x09
#define LIGHT_GREEN		0x0A
#define LIGHT_CYAN		0x0B
#define LIGHT_RED		0x0C
#define LIGHT_MAGENTA	0x0D
#define YELLOW			0x0E
#define WHITE			0x0F

/* These are the dimensions of the screen */
#define SCREEN_WIDTH	320
#define SCREEN_HEIGHT	200
#define VGA_MEM_BASE	0xA0000

/* Sample function to draw a single point */
void point( unsigned x, unsigned y, unsigned char color ){
	unsigned long offset = x + SCREEN_WIDTH * y;
	unsigned char *ptr = (unsigned char*) (VGA_MEM_BASE + offset);
	asm( "xchg %bx, %bx" );
	*ptr = color;
}

void box( unsigned x, unsigned y, unsigned w, unsigned h, unsigned char color ){
	int curr_x, curr_y;
	for( curr_x=0; curr_x < w; curr_x++ ){
		for( curr_y=0; curr_y < h; curr_y++ ){
			point( x + curr_x, y + curr_y, color );
		}
	}
}

void clear( int color ){
	asm(
		"movl %0, %%eax;"
		"movl $0x00003E80, %%ecx;"
		"movl $0x000A0000, %%edi;"
		"rep stosl;"
		:: "g" ( color + (color << 8) + (color << 16) + (color << 24) )
	);
}

/* Driver code */
void main(){
	clear( CYAN );
	
	box( 10, 10, SCREEN_WIDTH - 20, SCREEN_HEIGHT - 20, WHITE	);
	box( 20, 20, SCREEN_WIDTH - 40, SCREEN_HEIGHT - 40, RED		);
	box( 30, 30, SCREEN_WIDTH - 60, SCREEN_HEIGHT - 60, GREEN	);
	box( 40, 40, SCREEN_WIDTH - 80, SCREEN_HEIGHT - 80, BLUE	);
	
	point(                0,                 0, LIGHT_RED 	);
	point( SCREEN_WIDTH - 1,                 0, LIGHT_GREEN	);
	point(                0, SCREEN_HEIGHT - 1, LIGHT_BLUE	);
	point( SCREEN_WIDTH - 1, SCREEN_HEIGHT - 1, BLACK		);
	
	while(1);
}

